﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
Dim su As StringUtils	
Private iv As ImageView
Private p As Panel
Private  lb1, lb2 As Label
Private img As Bitmap
Private Bwidth, Height As Int 
'Public SEND As String  = "B1.png"
'Public RECEIVED As String  = "T1.png"
Public SEND As String  = "bubbleTx.png"
Public RECEIVED As String  = "bubbleRx.png"
Dim SF As Float
End Sub

'Initializes the object.
Public Sub Initialize(Act As Activity )
p.Initialize("")
iv.Initialize("")
lb1.Initialize("")
lb2.Initialize("")
SF = Max(Act.Width,Act.Height)/800
End Sub

'Sets the parameters of the labels appearance.
'text1 is the text of the first label, text2 is for the second label.
'Backcolor is the color of the baloon.
'Returns the height of the object ( to be used by addview)
Public Sub Appearance(BaloonType As String,textsize1 As Int, textsize2 As Int, textcolor1 As Int, textcolor2 As Int, text1 As String, text2 As String, Backcolor As Int,TextGravity As Int, Width As Int) As Int

lb1.text = text1
lb2.text = text2
lb1.TextSize = textsize1
lb2.TextSize = textsize2

lb1.Gravity = TextGravity
lb2.Gravity = TextGravity
lb1.textcolor = textcolor1
lb2.textcolor = textcolor2
p.Color = Backcolor
iv.Gravity = Gravity.FILL
img = LoadBitmap(File.DirAssets,BaloonType)
iv.SetBackgroundImage(img)

p.AddView(lb1,16dip*SF,19dip*SF,Width-32dip*SF,4dip*SF)
lb1.Height =  su.MeasureMultilineTextHeight(lb1,lb1.text)
p.AddView(lb2,16dip*SF,19dip*SF+lb1.Height,Width-32dip*SF,4dip*SF)
lb2.Height =  su.MeasureMultilineTextHeight(lb2,lb2.text)

lb1.Color = Colors.Transparent
lb2.Color = Colors.Transparent

Height =  lb1.Height+lb2.Height+40dip*SF
p.addview(iv,-1,-1,Width+3,Height+4)
iv.SendToBack
Bwidth = Width
Return Height
End Sub

'Modify the text of the two labels.
'The height of the baloon is re-calculated.
Sub setText(text1 As String, text2 As String)
lb1.text = text1
lb2.text = text2
lb1.Height = su.MeasureMultilineTextHeight(lb1,lb1.text)
lb2.SetLayout(16dip*SF,19dip*SF+lb1.Height,Bwidth-32dip*SF,4dip*SF)
lb2.Height = su.MeasureMultilineTextHeight(lb2,lb2.text)
Height =  lb1.Height+lb2.Height+40dip*SF
iv.Height = Height + 4
p.Height = Height + 2
End Sub

'Returns the panel which holds all the views.
Sub AsView As View
Return p
End Sub

'Flips the baloon so the tip can be on either side , top or bottom.
Sub Flip(Vertical As Boolean, Horizontal As Boolean)
Dim cnvs As Canvas
Dim src,dst As Rect
src.Initialize(0,0,img.Width,img.Height)
dst.Initialize(0,0,iv.Width,iv.Height)

cnvs.Initialize(iv)
cnvs.DrawRect(dst,Colors.Transparent,True,1)
cnvs.DrawBitmapFlipped(img,src,dst,Vertical,Horizontal)
iv.Invalidate
End Sub

'If the background of the parent view (activity or panel) is not black, it should be changed using this method.
'Use this method after Flip.
Sub MatchBackground(clr As Int)
Dim cnvs As Canvas
Dim dst As Rect
dst.Initialize(0,0,iv.Width,iv.Height)
cnvs.Initialize(iv)
For i = 1 To iv.Width-1
	For j = 1 To iv.Height-1
		If cnvs.Bitmap.GetPixel(i,j) <> Colors.Transparent Then cnvs.DrawPoint(i,j, clr)
	Next
Next
iv.Invalidate
End Sub